#if defined(MODVERSIONS)
#include <linux/modversions.h>
#endif

#include "../include/Adlsys.h"
#include "../include/Adldev.h"
#include "../include/Adllib.h"

#include "../include/Adlp9030.h"

#include "pci7260.h"

#include <linux/interrupt.h>

/*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>*/
static void p7260_bottom_half( PPCI_DEVEXT  pDevExt, U16 IntSrc )
{

    U16 wTemp = 0;
    /*-----------------------------------------------------*/
    // yuan add 01/11/99
    wTemp = (IntSrc >> 2 ) & 0x0007;

    if ( ! pDevExt->pDin )
        return;

    if ( IntSrc & 0x0001 ){
        if( !wTemp || (wTemp & 1) )
            adl_kill_fasync ( pDevExt->pDin->async_queue1, SIGEVENT1); /* asynchronous readers */
        if( wTemp & 2 )
            adl_kill_fasync ( pDevExt->pDin->async_queue2, SIGEVENT2);
        if(wTemp & 0x04){
            PPCI_DSEN  pDsen = pDevExt->pTcn;
            if(pDsen) {
                if(pDsen->async_queue1)
                adl_kill_fasync ( pDsen->async_queue1, SIGDBI); /* asynchronous readers */
            }
        }
    }
}

/*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>*/
// based on request_irq() called in File_Open , and the dev_id is the Dev_Extension called request_irq()
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,19)
irqreturn_t p7260_interrupt_handler(int irq, void *dev_id, struct pt_regs *regs)
#else
irqreturn_t p7260_interrupt_handler(int irq, void *dev_id)
#endif
{
    PPCI_DEVEXT  pDevExt;
    U16  wRetCode; /* 980918/pang */
    U16  wIntSts;

    /*-----------------------------------------------------*/
    pDevExt = (PCI_DEVEXT *)dev_id;
    wRetCode = PLX90_IsrCheckSource(OP_Port(pDevExt));
    if ((! (wRetCode & 0xff00))||(!(wRetCode & 0x0003)))
        return IRQ_NONE;

    wIntSts = PT_inpw( PT_Port(pDevExt), INTCSR );
    if( wIntSts & 0x01 ){
        // yuan add 10/05/01 for COS Lache data
        pDevExt->dwDevRA = PT_inpw( PT_Port(pDevExt), COSCSR );
        wRetCode &= 0x03;
    }
    else{
        if( wIntSts & 0x02 )
            wRetCode |= (1 << 2);
        if( wIntSts & 0x04 )
            wRetCode |= (1 << 3);
    }
    if(wIntSts & 0x10) { //watchdog int
        wIntSts &= 0x0fff;
        wIntSts |= 0x80;
        wRetCode |= (1 << 4);
        outW(PT_Port(pDevExt)+ADL_PT_WDT, (U16) (pDevExt->dwDevRB &=0xffff));
    }
    //from int_sts to int_ctrl //clear interrupt
    if(wIntSts&0x1000)
        wIntSts |= 0x8000;

    PT_outw( PT_Port(pDevExt), INTCSR, wIntSts & INT_MASK );
    P9030_SetInt(OP_Port(pDevExt), 1, 1, 1, 0, 1);
    P9030_SetInt(OP_Port(pDevExt), 1, 1, 1, 0, 0);

    if ( pDevExt->Reference <= 0)
        return IRQ_HANDLED;

    /* Get Interrupt Enable setting */
    p7260_bottom_half( pDevExt, wRetCode );
    return IRQ_HANDLED;
}
